#ifndef __SJAPELICAN_H__
#define __SJAPELICAN_H__
#include <absacc.h>
#include "config.h"

#define     FrameNum      13//һֽ֡

uint8       RX_buffer[FrameNum];  //յ
uint8       TX_buffer[FrameNum];  //յ
uint8       Txd_data = 0;//CANҪ͵ݣҲҪ1-2λʾ
uint8       Rxd_data = 0;//CANҪյݣҲҪ3-4λʾ


sbit SJA_RST = P2^0;//SJA1000λܽ
sbit SJA_CS  = P2^1;//SJA1000Ƭѡܽ

void MCU_Init(void);
void Peli_Init(void); // ʼCANоƬ
void Peli_TXD(void);//CANӺ
void LED_Disp_Seg7();//ʾӺ


#define SJA_BASE_ADR     0xfd00	 //ĴַĻַ

//SJA1000Ĵַ壬Peliģʽչ֡ʽ
/**********************
ģʽƼĴλ
************************/
#define SJA_MOD   XBYTE[SJA_BASE_ADR + 0x00]

#define RM_BIT     0x01  //λģʽλ
#define LOM_BIT    0x02  //ֻģʽλ
#define STM_BIT    0x04  //Լģʽλ
#define AFM_BIT    0x08  //˲ģʽλ
#define SM_BIT     0x10  //˯ģʽλ

/**********************
Ĵλ
************************/
#define SJA_CMR    XBYTE[SJA_BASE_ADR + 0x01]
#define TR_BIT         0x01       //λ
#define AT_BIT         0x02        //ֹλ
#define RRB_BIT        0x04        //ͷŽջλ
#define CDO_BIT        0x08        //λ
#define SRR_BIT        0x10        //λ

/**********************
״̬Ĵλ
************************/
#define SJA_SR     XBYTE[SJA_BASE_ADR + 0x02]
#define RBS_BIT           0x01                    //ջ״̬λ
#define DOS_BIT           0x02                     //״̬λ
#define TBS_BIT           0x04                      //ͻ״̬λ
#define TCS_BIT           0x08                      //״̬λ
#define RS_BIT            0x10                    //״̬λ
#define TS_BIT            0x20                     //״̬λ
#define ES_BIT            0x40                   //״̬λ
#define BS_BIT            0x80                    //״̬λ

/**********************
жϼĴλ
************************/
#define SJA_IR     XBYTE[SJA_BASE_ADR + 0x03]
#define RI_BIT            0x01                     //жλ
#define TI_BIT            0x02                      //жλ
#define EI_BIT            0x04                      //󾯸жλ
#define DOI_BIT           0x08                     //жλ
#define WUI_BIT           0x10                      //жλ
#define EPI_BIT           0x20                      //жλ
#define ALI_BIT           0x40                     //ٲöʧжλ
#define BEI_BIT           0x80                    //ߴжλ

/**********************
жʹܼĴλ
************************/
#define SJA_IER    XBYTE[SJA_BASE_ADR + 0x04]
#define RIE_BIT           0x01                     //жʹλ
#define TIE_BIT           0x02                      //жʹλ
#define EIE_BIT           0x04                      //󾯸жʹλ
#define DOIE_BIT          0x08                      //жʹλ
#define WUIE_BIT          0x10                      //жʹλ
#define EPIE_BIT          0x20                      //жʹλ
#define ALIE_BIT          0x40                      //ٲöʧжʹλ
#define BEIE_BIT          0x80                     //ߴжʹλ


#define SJA_BTR0   XBYTE[SJA_BASE_ADR + 0x06]	  //߶ʱ0Ĵ
#define SJA_BTR1   XBYTE[SJA_BASE_ADR + 0x07]	  //߶ʱ1Ĵ
#define SAM_BIT           0x80               //ģʽλ0==߱1Σ1== ߱3

/**********************
ƼĴλ
************************/
#define SJA_OCR    XBYTE[SJA_BASE_ADR + 0x08]
           /*OCMODE1 OCMODE0 */
#define BiPhaseMode       0x00                      //˫ģʽ
#define NormalMode        0x02                  //ģʽ
#define ClkOutMode        (0x01|0x02)       //ʱģʽ
           /*TX1 ܽ*/
#define OCPOL1_BIT        0x20                  //Կλ
#define Tx1Float          0x00                      //Ϊ
#define Tx1PullDn         0x40                  //Ϊ
#define Tx1PullUp         0x80                 //Ϊ
#define Tx1PshPull        (0x40|0x80)       //Ϊ
            /*TX0 ܽ*/
#define OCPOL0_BIT        0x04                      //Կλ
#define Tx0Float          0x00                      //Ϊ
#define Tx0PullDn         0x08                      //Ϊ
#define Tx0PullUp         0x10                      //Ϊ
#define Tx0PshPull        (0x10|0x08)                    //Ϊ

#define SJA_TEST   XBYTE[SJA_BASE_ADR + 0x09]         //ԼĴ

/********************************
 * #define SJA_10   XBYTE[SJA_BASE_ADR + 0x0a]   Ĵܱ
 ********************************/

/**********************
Ĵλ
************************/
#define SJA_ALC      XBYTE[SJA_BASE_ADR + 0x0b]		//ٲöʧ׽Ĵ
#define SJA_ECC      XBYTE[SJA_BASE_ADR + 0x0c]		//׽Ĵ
#define SJA_EWLR     XBYTE[SJA_BASE_ADR + 0x0d]		//󱨾ƼĴ
#define SJA_RXERR    XBYTE[SJA_BASE_ADR + 0x0e]		//RX Ĵ
#define SJA_TXERR    XBYTE[SJA_BASE_ADR + 0x0f]		//TX Ĵ

/**********************
˲Ĵλ
************************/
#define SJA_ACR0     XBYTE[SJA_BASE_ADR + 0x10]		//մ0Ĵ
#define SJA_ACR1     XBYTE[SJA_BASE_ADR + 0x11]		//մ1Ĵ
#define SJA_ACR2     XBYTE[SJA_BASE_ADR + 0x12]		//մ2Ĵ
#define SJA_ACR3     XBYTE[SJA_BASE_ADR + 0x13]		//մ3Ĵ

#define SJA_AMR0     XBYTE[SJA_BASE_ADR + 0x14]		//0Ĵ
#define SJA_AMR1     XBYTE[SJA_BASE_ADR + 0x15]		//1Ĵ
#define SJA_AMR2     XBYTE[SJA_BASE_ADR + 0x16]		//2Ĵ
#define SJA_AMR3     XBYTE[SJA_BASE_ADR + 0x17]		//3Ĵ

/**********************
TXַ
************************/
#define SJA_TBSR0    XBYTE[SJA_BASE_ADR + 0x10]
#define SJA_TBSR1    XBYTE[SJA_BASE_ADR + 0x11]
#define SJA_TBSR2    XBYTE[SJA_BASE_ADR + 0x12]
#define SJA_TBSR3    XBYTE[SJA_BASE_ADR + 0x13]
#define SJA_TBSR4    XBYTE[SJA_BASE_ADR + 0x14]
#define SJA_TBSR5    XBYTE[SJA_BASE_ADR + 0x15]
#define SJA_TBSR6    XBYTE[SJA_BASE_ADR + 0x16]
#define SJA_TBSR7    XBYTE[SJA_BASE_ADR + 0x17]
#define SJA_TBSR8    XBYTE[SJA_BASE_ADR + 0x18]
#define SJA_TBSR9    XBYTE[SJA_BASE_ADR + 0x19]
#define SJA_TBSR10   XBYTE[SJA_BASE_ADR + 0x1a]
#define SJA_TBSR11   XBYTE[SJA_BASE_ADR + 0x1b]
#define SJA_TBSR12   XBYTE[SJA_BASE_ADR + 0x1c]

/**********************
RXַ
************************/
#define SJA_RBSR0    XBYTE[SJA_BASE_ADR + 0x10]
#define SJA_RBSR1    XBYTE[SJA_BASE_ADR + 0x11]
#define SJA_RBSR2    XBYTE[SJA_BASE_ADR + 0x12]
#define SJA_RBSR3    XBYTE[SJA_BASE_ADR + 0x13]
#define SJA_RBSR4    XBYTE[SJA_BASE_ADR + 0x14]
#define SJA_RBSR5    XBYTE[SJA_BASE_ADR + 0x15]
#define SJA_RBSR6    XBYTE[SJA_BASE_ADR + 0x16]
#define SJA_RBSR7    XBYTE[SJA_BASE_ADR + 0x17]
#define SJA_RBSR8    XBYTE[SJA_BASE_ADR + 0x18]
#define SJA_RBSR9    XBYTE[SJA_BASE_ADR + 0x19]
#define SJA_RBSR10   XBYTE[SJA_BASE_ADR + 0x1a]
#define SJA_RBSR11   XBYTE[SJA_BASE_ADR + 0x1b]
#define SJA_RBSR12   XBYTE[SJA_BASE_ADR + 0x1c]

#define SJA_RMC      XBYTE[SJA_BASE_ADR + 0x1d]           //RX Ϣ Ĵ
#define SJA_RBSA     XBYTE[SJA_BASE_ADR + 0x1e]            //RX ʼַ Ĵ

/**********************
ʼշƵĴַ
************************/
#define SJA_CDR       XBYTE[SJA_BASE_ADR + 0x1f]		 //ʱӷƵ Ĵ
#define CLKOff_BIT        0x08                     //ʱӹرλʱܽſλ
#define RXINTEN_BIT       0x20                      //ڽжϵĹܽTX1
#define CBP_BIT           0x40                      //CAN Ƚ·λ
#define CANMode_BIT       0x80                     //CAN ģʽλ

#endif



